/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO (Extended = ExtendedPersistenceContext ConversationScope (Group = EntityExtendedDAO.class)
 *
 */

package de.ivu.elect.business.wahlvorschlag.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.wahlvorschlag.entity.Listenverbindung;
import de.ivu.elect.jee.entity.ExtendedDAO;

@javax.enterprise.context.RequestScoped
public class ListenverbindungExtendedDAO extends AbstractListenverbindungDAO implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  @Inject
  transient ExtendedDAO extendedDAO;

  @Inject
  transient de.ivu.elect.presentation.system.ExtendedDAORequestCache cache;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return extendedDAO.getEntityManager();
  }

  @Override
  public void flush() {
    extendedDAO.flush();
  }

  public void flushNewTransaction() {
    extendedDAO.flushNewTransaction();
  }

/**
* Name: BezeichnungNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT o FROM Listenverbindung o WHERE o.bezeichnung=?1<br>
* SQL: <br>
*/
@Override
public java.util.List<Listenverbindung> findByBezeichnung( @javax.annotation.Nonnull String bezeichnung) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Listenverbindung.findByBezeichnung" ,  bezeichnung  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByBezeichnung(): Miss");
        }

        cache.put(key, super.findByBezeichnung( bezeichnung  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByBezeichnung(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<Listenverbindung>) cache.lookup(key));
    }

    return super.findByBezeichnung( bezeichnung  );
}

  @Override
  public void clear() {
    cache.clear();

    super.clear();
  }
}
